/*
 * bsp.h
 *
 *  Created on: Jun 27, 2023
 *      Author: hussamaldean
 */

#ifndef BSP_H_
#define BSP_H_


#include "stdint.h"
#include "stm32f4xx.h"

typedef enum
{
	pin0=0,
	pin1,
	pin2,
	pin3,
	pin4,
	pin5,
	pin6,
	pin7,
	pin8,
	pin9,
	pin10,
	pin11,
	pin12,
	pin13,
	pin14,
	pin15
}Pins_Typedef;


typedef enum
{
	INPUT=0,
	OUTPUT,
	Alternate_function,
	Analog_Mode

}GPIO_ModeTypedef;


typedef enum
{
	Push_Pull=0,
	Open_Drain
}GPIO_Output_Type_Typedef;

typedef enum
{
	Low_Speed=0,
	Medium_Speed,
	Fast_Speed,
	High_Speed
}GPIO_OutputSpeed_Typedef;

typedef enum
{
	No_Pullup_PullDown=0,
	PullUp,
	PullDown
}GPIO_PullUPPullDown_Typedef;

typedef enum
{
	AF0=0,
	AF1,
	AF2,
	AF3,
	AF4,
	AF5,
	AF6,
	AF7,
	AF8,
	AF9,
	AF10,
	AF11,
	AF12,
	AF13,
	AF14,
	AF15,

}Alternate_Type_Typedef;


typedef enum
{
	Reset,
	Set

}GPIO_State_Typedef;


typedef struct
{
	uint8_t PinNumer;
	uint8_t Mode;
	uint8_t OutputType;
	uint8_t OutPutspeed;
	uint8_t PullUp_PullDown;
	uint8_t AlternateType;

}GPIO_Configure_Typedef;



typedef struct
{
	uint8_t pinMumber;
	uint8_t state;
}GPIO_Output_Typedef;

typedef struct
{
	uint8_t pinMumber;
}GPIO_Input_Typedef;

void GPIOA_CLOCK_ENABLE();

void GPIOC_CLOCK_ENABLE();

void GPIO_Initialization(GPIO_TypeDef *GPIO,GPIO_Configure_Typedef *GPIO_Config);

void GPIO_WritePin(GPIO_TypeDef *GPIO,GPIO_Output_Typedef *GPIOPin, GPIO_State_Typedef state );

void GPIO_TogglePin(GPIO_TypeDef *GPIO,GPIO_Output_Typedef *GPIOPin);

GPIO_State_Typedef GPIO_ReadPin(GPIO_TypeDef *GPIO,GPIO_Input_Typedef *pin);


#endif /* BSP_H_ */
