/*
 * bsp.c
 *
 *  Created on: Jun 27, 2023
 *      Author: hussamaldean
 */


#include "bsp.h"



void GPIOA_CLOCK_ENABLE()
{
	RCC->AHB1ENR|= RCC_AHB1ENR_GPIOAEN;
}

void GPIOC_CLOCK_ENABLE()
{
	RCC->AHB1ENR|= RCC_AHB1ENR_GPIOCEN;
}

void GPIO_Initialization(GPIO_TypeDef *GPIO,GPIO_Configure_Typedef * GPIO_Config)
{
	if (GPIO_Config->Mode !=Alternate_function)
	{


		GPIO->MODER &=~((0x03<<(GPIO_Config->PinNumer*2)));
		GPIO->MODER|= (GPIO_Config->Mode<< GPIO_Config->PinNumer*2);

		GPIO->OTYPER|= (GPIO_Config->OutputType<<GPIO_Config->PinNumer);

		GPIO->OSPEEDR|= (GPIO_Config->OutPutspeed<< GPIO_Config->PinNumer*2);

		GPIO->PUPDR|= (GPIO_Config->PullUp_PullDown<< GPIO_Config->PinNumer*2);
	}

}

void GPIO_WritePin(GPIO_TypeDef *GPIO,GPIO_Output_Typedef *GPIOPin, GPIO_State_Typedef state )
{

	switch (state)
	{
		case Reset:
			GPIO->BSRR = (1<<((GPIOPin->pinMumber) +16));
			GPIOPin->state=Reset;
			break;

		case Set:
			GPIO->BSRR = (1<<(GPIOPin->pinMumber));
			GPIOPin->state=Set;
			break;

		default: break;
	}
}

void GPIO_TogglePin(GPIO_TypeDef *GPIO,GPIO_Output_Typedef *GPIOPin)
{
	switch (GPIOPin->state)
	{
		case Reset:
			GPIO->BSRR = (1<<(GPIOPin->pinMumber));
			GPIOPin->state=Set;
			break;

		case Set:
			GPIO->BSRR = (1<<((GPIOPin->pinMumber) +16));
			GPIOPin->state=Reset;
			break;
	}
}

GPIO_State_Typedef GPIO_ReadPin(GPIO_TypeDef *GPIO,GPIO_Input_Typedef *pin)
{
	uint8_t temp;
	temp= (GPIO->IDR & (1<<pin->pinMumber))>>pin->pinMumber;
	return temp;
}
